% Cost Analysis Heat Exchanger
% Senior Design
% Last Updated: 3/22/15
clear all 
clc
close all

D = 4; % Units [m]
D_old = 5.5;
L = 10; % Units [m]
L_old = 21;

% All costs are in units of dollars.
%% Heat Exchanger
%% Initial Cost
Cs = 1800*(D^2.5)*L; % Cost of the shell % Units [$]
Cf = 350*D*L; % Initial cleaning cost % Units [$]
Ct = 1950; % First cost of the tubing % Units [$]
C = Cs + Cf + Ct

Cs = 1800*(D_old^2.5)*L_old; % Cost of the shell % Units [$]
Cf = 350*D_old*L_old; % Initial cleaning cost % Units [$]
Ct = 1950; % First cost of the tubing % Units [$]
C_old = Cs + Cf + Ct;

% Shipping Cost
Cost_shipping_HE = 5700;

% 104,000 lbs
%% Turbine
Cost_shipping_Turbine = 230;
% 1102 lbs
%% Compressor
Cost_shipping_compressor = 512;
% 650 lbs
%% Piping
Cost_shipping_piping = 121;
% 100 lbs
%% Solar Collector
Cost_shipping_solarcollector = 117;
% 150 lbs
%% Working Fluid
Cost_shipping_butane = 143;
% 33 lbs
%% Storage Tank
Cost_initial_storagetank = 1965.99;
Cost_shipping_storagetank = 445;
% 470 lbs

%% Estimated Labor Costs
numengineers = 2;
numlaborers = 10;
rate = 45; % $/hr
rate_lab = 20;
t = 160; % hours
Cost_engineers = numengineers*rate*t
Cost_laborers = numlaborers*rate_lab*t

T_C_I = Cost_shipping_HE+Cost_shipping_Turbine+...
    Cost_shipping_compressor+Cost_shipping_piping+...
    Cost_shipping_solarcollector+Cost_shipping_butane+...
    Cost_initial_storagetank+Cost_shipping_storagetank+Cost_engineers+...
    Cost_laborers+C;

T_C_I

%% Maintenance Costs
time_foul = 1:18; %weeks
f = 600*(time_foul.^2);
C_HE_M = 15000+f(time_foul);
Fouling_Model = 11000*time_foul.^(1/2);
AV_COST = (C_HE_M./(time_foul));

figure(1)
plot(time_foul,C_HE_M,'b',time_foul,Fouling_Model,'r',time_foul,AV_COST,'k')
xlabel('Weeks Since Last Cleaning'),ylabel('Total Cost of Losses ($)')
title('Heat Exchanger Cleaning Model'), grid on
axis tight
%% Annual Costs
annual_cost = 250000;
year = 1:50;
Extra = 1000000;
Cost_plot = T_C_I+Extra+(annual_cost*year);
MoneySaved = 335000*year;

x1 = year; x2 = x1; robust = 1;
y1 = MoneySaved;y2 = Cost_plot;
[x0,y0,iout,jout] = intersections(x1,y1,x2,y2,robust);
BREAKEVEN = x0;
BREAKEVEN

figure(2)
plot(year,Cost_plot,'r',year,MoneySaved,'b',BREAKEVEN,y0,'ko'), grid on
xlabel('Years'),ylabel('Dollars'),title('$ over time')
legend('Cost Plot','Money Saved','BREAKEVEN POINT','Location','northwest')


%% EXTRA COSTS TO BE DETERMINED
% INITIAL COSTS
% Cost of turbine
% Cost of compressor
% Cost of piping and insulation 
% Cost of solar collector