function varargout = GUI_SIM(varargin)
% GUI_SIM MATLAB code for GUI_SIM.fig
%      GUI_SIM, by itself, creates a new GUI_SIM or raises the existing
%      singleton*.
%
%      H = GUI_SIM returns the handle to a new GUI_SIM or the handle to
%      the existing singleton*.
%
%      GUI_SIM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_SIM.M with the given input arguments.
%
%      GUI_SIM('Property','Value',...) creates a new GUI_SIM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI_SIM before GUI_SIM_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_SIM_OpeningFcn via varargin.
%
%      *See GUI_SIM Options on GUIDE's Tools menu.  Choose "GUI_SIM allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI_SIM

% Last Modified by GUIDE v2.5 08-Apr-2015 11:14:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_SIM_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_SIM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
%% DON'T EDIT INITIALIZATION CODE EVER.



% --- Executes just before GUI_SIM is made visible.
function GUI_SIM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI_SIM (see VARARGIN)

% Create the data to plot
NumEng = [0 0 0 0 0];
NumEng = NumEng';
Day = 1;

[solar_time,T_Collector_out,TotalMassFlow,Total_Beam,True_powerout,Collector_efficiency,heat_Useful,T_out_heatexchange,SystemEfficiencyTrue,Annual_Energy_MWh,Annual_Energy_dol, HE_efficiency,HEheat_Useful]= SIM(NumEng,Day);
handles.T_Collector_out = T_Collector_out;
handles.Total_Beam = Total_Beam;
handles.TotalMassFlow = TotalMassFlow;
handles.solar_time = solar_time;
handles.True_powerout = True_powerout;
handles.Collector_efficiency = Collector_efficiency;
handles.heat_Useful = heat_Useful;
handles.T_out_heatexchange = T_out_heatexchange;
handles.SystemEfficiencyTrue = SystemEfficiencyTrue;
handles.Annual_Energy_MWh = Annual_Energy_MWh;
handles.Annual_Energy_dol = Annual_Energy_dol;
handles.HE_efficiency = HE_efficiency;
handles.HEheat_Useful = HEheat_Useful;

% Choose default command line output for GUI_SIM
handles.output = hObject;


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI_SIM wait for user response (see UIRESUME)
% uiwait(handles.Team2GUI);

% --- Outputs from this function are returned to the command line.
function varargout = GUI_SIM_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in plot_popup.
function plot_popup_Callback(hObject, eventdata, handles)
% hObject    handle to plot_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plot_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plot_popup
global Day
global NumEng
global TotalMassFlow

[solar_time,T_Collector_out,TotalMassFlow,Total_Beam,True_powerout,Collector_efficiency,heat_Useful,T_out_heatexchange,SystemEfficiencyTrue,Annual_Energy_MWh,Annual_Energy_dol,HE_efficiency,HEheat_Useful]= SIM(NumEng,Day);
val = get(hObject, 'Value');
str = get(hObject, 'String'); 

switch str{val}
    case 'Total Beam' % User selects Total Beam
        handles.current_data = handles.Total_Beam;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,Total_Beam)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Total Beam [W/m^2]')
        set(get(handles.axes1, 'Title'), 'String', 'Total Beam')
        avgvalue = mean(Total_Beam)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Temperature Out - Solar Collector' % User selects T_Collector_Out
        handles.current_data = handles.T_Collector_out;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,T_Collector_out)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Temperature [K]')
        set(get(handles.axes1, 'Title'), 'String', 'Temperature Collector Out')
        avgvalue = mean(T_Collector_out)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Turbine Power Output' % User selects Power Output
        handles.current_data = handles.True_powerout;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,True_powerout)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Power Output [kWe]')
        set(get(handles.axes1, 'Title'), 'String', 'Turbine Power Output')
        avgvalue = mean(True_powerout)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Collector Efficiency' % User selects Collector Efficiency
        handles.current_data = handles.Collector_efficiency;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,Collector_efficiency)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Efficiency')
        set(get(handles.axes1, 'Title'), 'String', 'Solar Collector Efficiency')
        avgvalue = mean(Collector_efficiency)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Collector Energy Useful' % User selects Collector Energy Useful
        handles.current_data = handles.heat_Useful;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,heat_Useful)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Heat Energy [kWt]')
        set(get(handles.axes1, 'Title'), 'String', 'Collector Heat Energy Useful')
        avgvalue = mean(heat_Useful)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Temperature Out - Heat Exchanger' % User selects Temp Out HE
        handles.current_data = handles.T_out_heatexchange;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,T_out_heatexchange)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Temperture [K]')
        set(get(handles.axes1, 'Title'), 'String', 'Heat Exchanger Temperature Out')
        avgvalue = mean(T_out_heatexchange)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'System Efficiency' % User selects System Overall Efficiency
        handles.current_data = handles.SystemEfficiencyTrue;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,SystemEfficiencyTrue)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'System Efficiency')
        set(get(handles.axes1, 'Title'), 'String', 'Overall System Efficiency')
        avgvalue = mean(SystemEfficiencyTrue)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        filename = 'posterplot1.xlsx';
        xlswrite(filename,SystemEfficiencyTrue);
        xlswrite(filename,solar_time,'B1');
    case 'Annual Energy Generated' % User selects Annual energy generated
        handles.current_data = handles.Annual_Energy_MWh;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,Annual_Energy_MWh)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Energy [MWh]')
        set(get(handles.axes1, 'Title'), 'String', 'Annual Energy Estimation based off day selected')
        avgvalue = mean(Annual_Energy_MWh)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Annual Average')
        filename = 'posterplot2.xlsx';
        xlswrite(filename,Annual_Energy_MWh);
        xlswrite(filename,solar_time,'B1');
    case 'Annual Revenue Generated' % User selects Annual energy generated
        handles.current_data = handles.Annual_Energy_dol;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,Annual_Energy_dol)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Revenue [$]')
        set(get(handles.axes1, 'Title'), 'String', 'Annual Energy Estimation based off day selected')
        avgvalue = mean(Annual_Energy_dol)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Annual Average')
        
    case 'Heat Exchanger Efficiency' % User selects Heat Exchanger Efficiency
        handles.current_data = handles.HE_efficiency;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,HE_efficiency)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Efficiency')
        set(get(handles.axes1, 'Title'), 'String', 'Heat Exchanger Efficiency')
        avgvalue = mean(HE_efficiency)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
        
    case 'Heat Exchanger Heat Useful' % User selects Heat Exchanger Energy Useful
        handles.current_data = handles.HEheat_Useful;
        %cla(handles.axes1,'reset')         % This will clear axis and make figure blank
        plot(solar_time,HEheat_Useful)
        set(get(handles.axes1, 'XLabel'), 'String', 'Solar Time [hr]')
        set(get(handles.axes1, 'YLabel'), 'String', 'Heat Energy [kWt]')
        set(get(handles.axes1, 'Title'), 'String', 'Heat Exchanger Heat Energy Useful')
        avgvalue = mean(HEheat_Useful)
        set(handles.text12, 'String', avgvalue) % Changes displayed average result
        set(handles.text10, 'String', 'Daily Average')
   
end
guidata(hObject,handles);

%% DO NOT EDIT THIS CODE, IT IS THE OPTIONS FOR POP UP MENU
% --- Executes during object creation, after setting all properties.
function plot_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%% YOU MAY CONTINUE EDITING

% --- Executes on button press in calendar_pushbutton.
function calendar_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to calendar_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Call the calendar function uisetdate.m, in command window, displays date,
% and nd (number of days 1-365), then it should put nd as the input for day
% in the SIM.m file.

[datet,Y,M,D,nD]=uisetdate;
global Day
Day = nD;
set(handles.text2, 'String', datet) % Changes date underneath calendar push button.
set(handles.text3, 'String', Day) % Changes date underneath calendar push button.


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
% Only using global variables because I haven't completely figured it out
% yet.
k =1;
data = get(hObject, 'data');
global NumEng;
NumEng = data;
% Tried to force the user to only input positive integer numbers, still
% working on it.
%{
while k < 6
if NumEng(k) < 0
    msgbox('Enter a valid number','Error','error')
    set(hObject,'data',[0 0 0 0 0]')
    break
end
end
%}
% Use the lines below to test NumEng was working correctly.
%{
whos NumEng
disp('The number of Engines Running are:')
NumEng
%}
engsum = sum(NumEng);
engremain = 96 - engsum;

set(handles.text_engsum, 'String', engsum) % Changes total # engines right of table.
set(handles.text_engremain, 'String', engremain) % Changes engines remaining right of table.
set(handles.text_totalmassflow, 'String', 'Press Calculate!') % Changes engines remaining right of table.
if engsum > 96
    msgbox('Maximum Number of Engines is 96.','Error','error')
    set(hObject,'data',[0 0 0 0 0]')
set(handles.text_engsum, 'String', 0) % Changes total # engines right of table.
set(handles.text_engremain, 'String', 96) % Changes engines remaining right of table.
set(handles.text_totalmassflow, 'String', 0) % Changes engines remaining right of table.

end
% --- Executes on button press in pushbutton_calculate.
function pushbutton_calculate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = get(handles.uitable1,'Data');
global TotalMassFlow
global Day
global solar_time
global NumEng;
NumEng = data;

[solar_time,T_Collector_out,TotalMassFlow]=SIM(NumEng,Day);

disp('Total Mass Flow (in kg/s) - GUI IS WORKING')
TotalMassFlow
set(handles.text_totalmassflow, 'String', TotalMassFlow(1)) % Changes engines remaining right of table.

% --- Executes on button press in pushbutton_help.
function pushbutton_help_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
msgbox({'Troubleshooting Tips' ' '...
    '1) Press the "Reset" button to return all variables to their original state.'...
    ' '...
    '2) First, select a date using the "Calendar" push button. The date will be displayed along with the day of the year from 1-365 (366 for leap year) on the main GUI figure.'...
    ' '...
    '3) Next, edit the "Number of Engines Running" Table with the appropriate numbers. The "Engine Sum" box to the right of the table will update to display the current Total Number of Engines and the Engines Remaining. For best results, select only whole integer numbers for the amount of engines running.'...
    ' '...
    '4) To calculate the Total Mass Flow, click the "Calculate!" push button.'...
    ' '...
    '5) To select which plot you would like to view, click on the drop down menu located beneath the figure. Then, select which parameter you would like to view from the list. The resulting plot will be displayed in the figure above the drop down list.'...
    ' '...
    '6) To view multiple results on the same plot, click the "Toggle Hold Plot" toggle button once to enable the plot to display several different results for various days of the year. It should be noted that the comparison of data will be best if the same parameter is plotted for different dates.'});

% --- Executes on button press in pushbutton_reset.
function pushbutton_reset_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.togglebutton2,'Value',0) % Reset the toggle to untoggled.
cla(handles.axes1,'reset')         % This will clear axis and make figure blank
set(handles.text_engsum, 'String', 0) % Reset total # engines right of table.
set(handles.text_engremain, 'String', 96) % Reset engines remaining right of table.
set(handles.text_totalmassflow, 'String', 0) % Reset engines remaining right of table.
set(handles.text2, 'String', 'Date') % Reset date underneath calendar push button.
set(handles.text3, 'String', 'Day') % Reset date underneath calendar push button.
clc
clear handles.current_data
set(handles.uitable1,'Data',[0 0 0 0 0]');  % Reset table values to zeros.

% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2
togglehold = get(handles.togglebutton2,'Value');
        if togglehold == 1
            hold on
           % plot(handles.solar_time,handles.current_data,'r')
           % legend('1st Choice', '2nd choice')
        elseif togglehold == 0
            hold off
        end

%% Extra functions that need to be in code because it messes up 
%  the OpeningFcn if they aren't included. DO NOT EDIT

% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1


% --- Executes during object creation, after setting all properties.
function text_engsum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_engsum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
