%Senior Design
%PipeLosses/Heat losses 

clc
clear all

numberofpoints = 20;
e = 0.0046;%Commerical Steel Roughness
PD = 0.5; % [m]
thickness = 0.0307; % [m]
g = 9.81;
nB_density = 2.48; % [kg/m^3] Vapor stage
Leq = 25; % [m]
T_ambient = 20; %Degrees C

%%%Piping Material Properties
k_bearsteel = 43; %W/m*K
cp_nbutane = 2282; %J/kg*K
k_nbutane = 0.0342;


%%%Butane_mass_flow = 40; % [kg/s]
AreaPipe = (PD^2)*(pi/4);
dynamic_viscosity = (0.0000124);%Pa*s
kinematic_viscosity = dynamic_viscosity / nB_density;

%%%%%% Heat Exchanger to Turbine %%%%%%
F = zeros(1,numberofpoints); %rows x columns
P_turbinein = zeros(1,numberofpoints);
%%%VBT = Butane_mass_flow / (AreaPipe * nB_density)
P_boilerout(1:numberofpoints) = 1000000; % PressureofVaporout Pa
Vbt =  linspace(1,25,numberofpoints); %[m/s] Velocity From boiler to inlet of Turbine %%%%%%%%%%%%%%%%%%%%%
Re = (Vbt.*PD ./ kinematic_viscosity);

i = 1; 
j = 1;
n = 1;

%Finding the Frictional Factor for different Re #
while i <= numberofpoints
    
if Re(j) > 2100
    F(n) = (-2.*log((e./3.7065.*PD) - (5.0452./Re(j)).* ...
        log(((1/2.8257).*((e./PD)^1.1098))+ ...
        (5.8506./(Re(j).^(.8981)))))).^(-2);
else
    F(n) = 64./Re(j);
end

P_turbinein(n) = -(nB_density*g).*(((F(n).*(Leq/PD)).*((Vbt(n).^2)./(2*g)))...
    - (P_boilerout(n)./(nB_density*g)));

i = i+1;
j = j+1;
n = n+1;
end
Reynolds_Number1 = transpose(Re);
Friction_Factor1 = transpose(F);
Pressure_Turbine_in = transpose(P_turbinein);

Pr = kinematic_viscosity / k_nbutane;
Nu = 0.023.*(Reynolds_Number1.^0.8).*(Pr^0.3);
h1a = (Nu.*k_nbutane)./PD;
critical = k_nbutane./h1a
R_conv1 = 1./(pi.*PD.*Leq.*h1a);
R_conduction1 = log((PD+(2*thickness))/PD) ./ (2*pi*Leq*k_bearsteel);

R_conv2 = 1 ./ (pi*PD*Leq)

%%%%%% Turbine To Compressor %%%%%%
P_lossturbine = 500000; %%%%%%%%%%%%% HAVE TO FIGURE THIS OUT %%%%%%%%%%%%%
P_turbineout = P_turbinein - P_lossturbine;
transpose(P_turbineout);
F2 = zeros(1,numberofpoints); %rows x columns
P_compressin = zeros(1,numberofpoints);
Leq2 = 25; % [m]
Vtc =  linspace(1,6,numberofpoints) ; %[m/s] %Velocity From boiler to inlet of Turbine
Re2 = (Vtc.*PD ./ kinematic_viscosity);

i = 1;
j = 1;
n = 1;

%Finding the Frictional Factor for different Re #
while i <= numberofpoints
    
if Re2(j) > 2100
    F2(n) = (-2.*log((e./3.7065.*PD) - (5.0452./Re2(j)).* ...
        log(((1/2.8257).*((e./PD)^1.1098))+ ...
        (5.8506./(Re2(j).^(.8981)))))).^(-2);
else
    F2(n) = 64./Re2(j);
end

P_compressin(n) = -(nB_density*g).*((F2(n).*(Leq2/PD)).*((Vtc(n).^2)./(2*g))...
    - (P_turbineout(n)./(nB_density*g)));

i = i+1;
j = j+1;
n = n+1;
end
Pressure_Compressor_in = transpose(P_compressin)

%%%%%% Compressor To Boiler %%%%%%

P_compressout(1:numberofpoints) = 1100000; % this would be a set value
F3 = zeros(1,numberofpoints); %rows x columns
P_boilerin = zeros(1,numberofpoints);
Leq3 = 25; % [m]
Vcf =  linspace(1,6,numberofpoints) ; %[m/s] %Velocity From boiler to inlet of Turbine
Re3 = (Vcf.*PD ./ kinematic_viscosity);
i = 1;
j = 1;
n = 1;

while i <= numberofpoints
    
if Re3(j) > 2100
    F3(n) = (-2.*log((e./3.7065.*PD) - (5.0452./Re3(j)).* ...
        log(((1/2.8257).*((e./PD)^1.1098))+ ...
        (5.8506./(Re3(j).^(.8981)))))).^(-2);
else
    F3(n) = 64./Re3(j);
end

P_boilerin(n) = -(nB_density*g).*((F3(n).*(Leq3/PD)).*((Vcf(n).^2)./(2*g))...
    - (P_compressout(n)./(nB_density*g)));

i = i+1;
j = j+1;
n = n+1;
end
Pressure_Boiler_in = transpose(P_boilerin);




