%Team 2
%Senior Design  Solar Estimates

clc
a = 0.14;
h = .192; % km above sea level
AM = 1.5; % Air Mass Index [100 units]
I_o = 1365; % Outside Atmosphere W/m^2
ALPHA = zeros(1,100);
time_day = zeros(1,100);
zenith = zeros(1,100);
azimuth = zeros(1,100);
Insolation = zeros(1,100);
azimuth_y = zeros(1,100);
azimuth_x = zeros(1,100);
ratio = zeros(1,100);

%%% Building Dimensions %%%
Length1 = 100;
Width1 = 120;
Length2 = 40;
Width2 = 40;
Area_Building1 = Length1*Width1; %% meter squared
Area_Building2 = Length2*Width2; %% meter squared
Total_Area = Area_Building1*.1 + Area_Building2;


%%% Solar Time throughout the day %%%
day =   input('What day of the year is it = ');
sunrise = input('What is sunrise solar time = ');%solar
sunset =  input('What is sunset solar time = ');
zeta = 180; % directions that the solar panels face


%%% Coordinates for Indiana %%%
lamda = Coordinate_Time(39,12,4.49298); % lattitude
W = Coordinate_Time(85,54,13.0428); % Lonigtude
elevation = lamda;
cloud = .70; %%% Cloudyness factor

%%% Average Insolation Equation %%%
I_local = I_o.*((1-a.*h).*(0.7.^(((AM).^0.678))) + (a.*h))

declination = 23.44.*sind(360*((day-80)/365.25));

for i=1:100
    
    time_day(i) = sunrise + ((sunset-sunrise)/99)*(i-1);
    ALPHA(i) = 15.*(time_day(i) - 12);
    zenith(i) = acosd(sind(declination).*sind(lamda) + ...
        cosd(declination).*cosd(lamda).*cosd(ALPHA(i)));
    azimuth_y(i) = sind(ALPHA(i));
    azimuth_x(i) = (sind(lamda).*cosd(ALPHA(i)) - ...
        cosd(lamda).*tand(declination));
    ratio(i) = azimuth_y(i) ./ azimuth_x(i);
    azimuth(i) = atan2d(azimuth_y(i), azimuth_x(i));
    
    if ALPHA(i) > 0 &&  ratio(i) > 0
        azimuth(i) = 180 + azimuth(i);
    elseif ALPHA(i) > 0 && ratio(i) < 0
        azimuth(i) = 360 + azimuth(i)  ;
    elseif ALPHA(i) < 0 && ratio(i) < 0
        azimuth(i) = 180 + azimuth(i);
    elseif ALPHA(i) == 0
        azimuth(i) = 180;
        
    end
    
    Insolation(i) = cloud.*(I_local.*(cosd(elevation).*cosd(zenith(i)) + ...
        sind(elevation).*sind(zenith(i)).*cosd(azimuth(i) - zeta)));
     
end

Sun = mean(Insolation) %% Calculationg the Mean Insolation

%%% Plots
plot(time_day,Insolation)
xlabel('Time (Hr)')
ylabel('Insolation')
title('Insolation in Day')
grid on
