% Solar Panel Number Calculations 60x20 section
clc
%Solar Panel Dimensions
Length = 1.675; %m
Width = 1.001; %m
Edge_Spacing = 0.5; % Spacing From the Edge (m)
Spacing = Edge_Spacing; % Spacing between Panels (m)
Roof_Sections = 1; % Sections for solar panels
AverageSunshine = 4.21;

Total_Length = 35;% Total Length of Section (m)
Total_Width = 35; % Total Width of Section (m)

N_Long = (Total_Length - (2*Edge_Spacing) + Spacing)./...
    (Length + Spacing);
N_Wide = (Total_Width - (2*Edge_Spacing) + Spacing)./...
    (Width + Spacing);
Panels_Section = N_Long * N_Wide;

Total_Number_Panels = Roof_Sections * Panels_Section 

%Solar Panel Specifications
V_max = 27.6; %% Adjusted for 600 Insolation
I_max = 5.205; %% Adjusted for 600 Insolation
P_max = V_max * I_max;

Voltage_Row = V_max * N_Long  % Volts
Current_Wide = I_max * N_Wide % Amps
Power_Section = Voltage_Row * Current_Wide

Power_System = Power_Section * Roof_Sections
Power_System_kWhr_day = (Power_System * AverageSunshine) / 1000;
Power_System_kWhr_year = (Power_System_kWhr_day * 365)

%%% Cost of Panels
Cost_Of_Electricity = .08; %Cents/kWhr
One_Panel_Dollars = 270;
Cost_Of_Panels = One_Panel_Dollars * ...
        Total_Number_Panels
%%% LCOE
Average_Hour_Worker = 19.53;
Worktime = 400;
KI = Cost_Of_Panels;
KMaintenance = Average_Hour_Worker * Worktime;
Kfuel = 0;
E_annual = Power_System_kWhr_year;
Interest_Rate = .1; %% 10 percent interest rate
n = 20;             % Number of years to pay back investment.

CRF = ((Interest_Rate)*(1+Interest_Rate)^n) / (((1+Interest_Rate)^n) - 1);

LCOE = (CRF * KI + KMaintenance) / E_annual; % Cents per kWhr





